



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>数据中心内负载均衡-ECMP的使用分析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">数据中心内负载均衡-ECMP的使用分析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-13 01:58:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>背景</h1>
<p>数据中心的网络拓扑通常采用CLOS结构，主机之间常存在多条路径。数据中心为满足吞吐量敏感型流量的需求会提供大量的带宽资源。那么利用数据中心这种网络拓扑已知，路径资源、带宽资源丰富的特性，可以更好的实现负载均衡，将数据流分布到不同路径上进行数据传输，避免拥塞，提高数据中心内的资源利用率。<br /><img referrerpolicy="no-referrer"src="https://img1.sdnlab.com/wp-content/uploads/2018/03/load-balance-ECMP-668x400.jpg" /></p>
<h1>ECMP(Equal-cost multi-path)</h1>
<p>ECMP是一个逐跳的基于流的负载均衡策略，当路由器发现同一目的地址出现多个最优路径时，会更新路由表，为此目的地址添加多条规则，对应于多个下一跳。可同时利用这些路径转发数据，增加带宽。ECMP算法被多种路由协议支持，例如：OSPF、ISIS、EIGRP、BGP等。在数据中心架构VL2中也提到使用ECMP作为负载均衡算法。</p>
<p>对于未开启ECMP的网络来说，无法充分利用路径资源。如图1所示，假设从S0到Server的为S0-S1-S2-S4即图中橘色路径，那么即便存在另一条等价路径，蓝色路径，路由器仍然会每次选择第一条橘色路径转发数据。除非此条路径发生拥塞，才会重新选择路径。</p>
<p>当开启ECMP功能时，便可同时利用两条路径，进行基于流的负载均衡，例如主机A到Server的数据流选择橘色路径，主机B到Server的数据流选择蓝色路径。</p>
<p>ECMP的路径选择策略有多种方法：</p>
<ul><li>哈希，例如根据源IP地址的哈希为流选择路径。</li>
<li>轮询，各个流在多条路径之间轮询传输。</li>
<li>基于路径权重，根据路径的权重分配流，权重大的路径分配的流数量更多。</li></ul>
<p><img referrerpolicy="no-referrer"src="https://img1.sdnlab.com/wp-content/uploads/2018/03/ECMP-fig-1.png" /></p>
<h4>图1.使用ECMP进行负载均衡</h4>
<h1>ECMP面临的问题</h1>
<p>然而ECMP是一种较为简单的负载均衡策略，其在实际使用中面临的问题也不容忽视。</p>
<p><strong>1.可能增加链路的拥塞</strong><br />ECMP并没有拥塞感知的机制，只是将流分散到不同的路径上转发。对于已经产生拥塞的路径来说，很可能加剧路径的拥塞。而使用哈希的方法，产生哈希碰撞也会增加链路的拥塞可能。</p>
<p><strong>2.非对称网络使用效果不好</strong><br />例如图2中，A与h3之间的通信，ECMP只是均匀的将流通过B,D两条路径分别转发，但实际上，在B处可以承担更多的流量。因为B后面还有两条路径可以到达h3。<br /><img referrerpolicy="no-referrer"src="https://img1.sdnlab.com/wp-content/uploads/2018/03/ECMP-fig-2.png" /></p>
<h4>图2. 非对称网络</h4>
<p><strong>3.基于流的负载均衡效果不好</strong><br />ECMP对于流大小相差不多的情况效果更好，而对于流大小差异较大，例如大象流和老鼠流并存的情况下，效果不好。如图2，主机h1到A的流量为15，h2到A的流量为5。那么无论为h1的流量选择哪条路径都会发生拥塞。但若将h1的流拆分成两部分传输，可以避免拥塞的情况。</p>
<p>以上，为使用ECMP算法进行负载均衡的分析，在数据中心这种突发性流量多，大象流与老鼠流并存的环境中，需要慎重考虑选择的负载均衡策略，ECMP简单易部署但也存在较多问题需要注意。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rql53o68.html">spring &commat;ModelAttribute 注解</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pgm149.html">java文件名更改一直是false&comma;看看是否是文件打开没有关</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rkv7mq.html">ThinkPHP3&period;2 G函数代码及 使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwe0ryq.html">PHP函数 rtrim&lpar;&rpar; 的一个怪异现象</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8owpkl9.html">sublime text 2 配置php调试环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/90velmm8.html">Top 10 Programming Fonts</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzn2ol8.html">浅谈IOS8之size class</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzp6yl8.html">Akamai在内容分发网络中的算法研究（翻译总结）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1p4j1q.html">python中关于文件的读取和写入</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k7jv59.html">redis与CPU、内存</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1m1g2q.html">mongo 根据对象中的某个条件来查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7om3x18.html">Assembly Experiment9</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvym1j8.html">VS2017 下载离线MSDN文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m24260q.html">linux&lpar;centos&rpar; 添加系统环境变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy7lgxq.html">python基础之小数据池，is和&equals;&equals;区别 编码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjw4xe9.html">dos命令：window10程序控制命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1mn2pq.html">由于未能创建Visual C&num; 2015编译器，因此未能打开项目xxx。请重新安装Visual Studio。</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1kynx9.html">16款值得一用的iPhone线框图模板 &lpar;PSD &amp;amp&semi; Sketch）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpxxll9.html">Java并发编程原理与实战三十四：并发容器CopyOnWriteArrayList原理与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm6n009.html">linux实现防止恶意扫描 PortSentry</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j16n2l9.html">python 分类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw1zzj9.html">Python 中的垃圾回收机制--备忘</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv6wm38.html">pho文件操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw6g4y8.html">关于Mysql安装启动的若干问题解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ov07j8.html">Delphi 中big5 转 Unicode 函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e46rvm9.html">Git -- 本地 一个相同的新的分支 并 推送到远程仓库</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rodr68.html">maven学习一（HelloWorld工程）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1po2eq.html">GraphQL&colon; Object doesn&amp;&num;39&semi;t support property or method &amp;&num;39&semi;from&amp;&num;39&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlld72xq.html">Nginx反向代理WebSocket</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r0nvj9.html">WIN10平板 如何设置不允许切换竖屏</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
